
#include <sys/types.h>
#include <sys/stat.h>

#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#include "functions.h"

int fd;
int log_fd;

int main(int argc, char *argv[])
{
 char line[80];
 short int tty_only=0;

 argc--;
 
 while (argc)
 {
  if (strcmp("-h",argv[argc])==0) {
	printf("Advice of charge for ISDN (using netMod)\n");
	printf("Usage %s [-h] [-t]\n",argv[0]);
	printf("\n\t-h : print this help message\n");
	printf("\t-t : output to terminal only\n\n");

	exit(0);
  }
  else {
  	if (strcmp("-t",argv[argc])==0)
  		tty_only=1;
  	else {
		printf("%s: %s: wrong option. Use -h\n",argv[0],argv[argc]);
		exit(1);
	}
  }
  
  argc--;
 }

 /* Open netMod device for initializing */

 fd=open(netMod,O_WRONLY|O_NONBLOCK);

 if (fd<0)
 {
  perror("aoc:Device netMod opening (r/w) failed");
  exit(1);
 }


 /* Open log file or set output to console */

 if (tty_only) {
 	log_fd=1;
 }
 else {
	 log_fd=open_log();

	 if (log_fd<0)
	 {
	  perror("aoc:Error opening log file");
	  exit(1);
	 }
 }


 /* Lock netMod */

 if (lock_netMod())
 {
  perror("aoc:Error creating lock file");
  exit(1);
 }



 /* Init netMod */

 if (init_netMod(fd))
 {
  perror("aoc:Error initializing netMod");
  unlink(lockfile);
  exit(1);
 }


 /* Close netMod device, and open again with SYNC option */

 close(fd);
 
 fd=open(netMod,O_RDWR|O_SYNC);

 if (fd<0)
 {
  perror("aoc:Device netMod opening (r/w) failed");
  unlink(lockfile);
  exit(1);
 }


 
 /* Reset netMod */

 if (reset_netMod(fd,line))
 {
  write(1,"aoc:Error reseting netMod\n",22);
  unlink(lockfile);
  exit(1);
 }


 
 /* Add new entry to Log */

 if (new_entry(fd,log_fd,line))
 {
  write(1,"aoc:Error writting entry\n",25);
 }


 unlink(lockfile);
 return 0;
}
